<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Config Library</h1>

		<p>The config library provides an interface for retrieving configuration options.  These options can be from
		the CarbonPHP configuration file <b>application/config/config.php</b> or from a custom configuration file.
		<i>Note</i>: the config library is automatically loaded by CarbonPHP so there is no need for you to load
		it.</p>
	</div>

	<div class="content">
		<h1>Configuration File Anatomy</h1>

		<p>CarbonPHP by default only uses one configuration file <b>application/config/config.php</b>.  When you view
		this file in a text editor you will see all the options are stored in a PHP array called <b>$config</b>.</p>

		<p>CarbonPHP allows you to add your own configuration options to this file, or if you wish to keep your
		configuration options separately you can simply create a file in the <b>application/config/</b> directory.</p>

		<p><i>Note</i>: if you choose to create your own configuration files you should follow the same format as the
		CarbonPHP configuration file.  Configuration options should be stored in an array called <b>$config</b>.
		CarbonPHP will be able to manage these files so that there will be no conflict.</p>
	</div>

	<div class="content">
		<h1>Loading a Configuration File</h1>

		<p>CarbonPHP automatically loads the CarbonPHP configuration file <b>application/config/config.php</b>.
		You will only have to load your own configurations files if you have created them.</p>

		<p>There are two methods of loading your own configuration files.</p>

		<ol>
			<li>
				<b>Manual Loading</b>

				<p>To load one of your own configuration files, you will use the following method within a controller
				to load it</p>

				<div class="example">
					$this->config->load('<b>filename</b>');
				</div>

				<p>Where <b>filename</b> is the name of your configuration file without the file extension.</p>

				<p>If you need to load multiple configuration files, they are normally merged into one array.  This
				means that array index name collisions can occur.  However if you have identical array index names in
				different configuration files you can set the second parameter to <b>true</b> and each configuration
				file will be stored in an array index corrosponding to the name of the configuration file.</p>

				<div class="example">
					// Stored in an array with the prototype: $this->config['blog_settings'] = $config;<br />
					$this->config->load('<b>blog_settings</b>', <b>true</b>);
				</div>

				<p>The loading method has a third parameter that will allow you to supress errors if a configuration
				file is not found.</p>

				<div class="example">
					$this->config->load('<b>blog_settings</b>', <b>false</b>, <b>true</b>);
				</div>
			</li>

			<li>
				<b>Automatically Loading</b>

				<p>If you find that you're loading your configuration a lot for different controllers, you may wish
				to have that configuration file loaded automatically.  To do this you need to edit the
				<b>application/config/autoload.php</b> file, and add your configuration file as the comments say.</p>
			</li>
		</ol>
	</div>

	<div class="content">
		<h1>Retrieving Configuration Options</h1>

		<p>To retrieve a configuration option from your configuration file, you can do the following.</p>

		<div class="example">
			$this->config->get_config_value('<b>item_name</b>');
		</div>

		<p>Where <b>item_name</b> is the name of the $config array index you wish to retrieve.  For example if you
		wish to retrieve the logging threshold you have set, you do the following.</p>

		<div class="example">
			$threshold = $this->config->get_config_value('<b>logging_threshold</b>');
		</div>

		<p>The method will return <b>false</b> if the configuration option you're trying to get does not exist.</p>

		<p>If you chose the use the second parameter of the <b>load()</b> method in order to assign your configuration
		items to a specific array index you can retrieve it by specifying the index name in the second parameter of
		the <b>get_config_value()</b> method.</p>

		<div class="example">
			$this->config->load('<b>blog_settings</b>, <b>true</b>);<br />
			<br />
			$site_name = $this->config->get_config_value('<b>site_name</b>', '<b>blog_settings</b>');<br />
			<br />
			// You can also do the following...<br />
			$blog_config = $this->config->get_config_value('<b>blog_settings</b>');<br />
			$site_name = $blog_config['site_name'];
		</div>
	</div>

	<div class="content">
		<h1>Setting Configuration Options</h1>

		<p>If you wish to dynamically change the value of a configuration option you can do the following.</p>

		<div class="example">
			$this->config->set_config_value('<b>item_name</b>', '<b>new_item_value</b>');
		</div>

		<p>Where <b>item_name</b> is the name of the index of the <b>$config</b> array you wish to change, and
		<b>new_item_value</b> is the new value of the item.  <i>Note</i>: any dynamic changes made to configuration
		files are not saved after CarbonPHP finishes executing.</p>
	</div>

	<div class="content">
		<h1>Helper Methods</h1>
		
		<p>The configuration class provides the following helper methods.</p>

		<h1>$this->config->get_site_url()</h1>
		
		<p>This method retrieves the URL to your site, along with the 'index' value you've specified in the configuration
		file.</p>
		
		<h1>$this->config->get_system_url()</h1>
		
		<p>This method retrieves the URL to your <b>carbon</b> folder.</p>

		<h1>$this->config->get_application_url()</h1>
		
		<p>This method retrieves the URL to your <b>application</b> folder.</p>
	</div>
</body>

</html>
